diff -urN Original_4.4.4_r1/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/vData.java AndroidSource/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/vData.java
--- Original_4.4.4_r1/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/vData.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/vData.java	2015-12-02 18:43:22.000000000 +0900
@@ -0,0 +1,109 @@
+package com.remote.surfaceprovider;
+
+import java.io.Serializable;
+
+public class vData implements Serializable{
+
+	private String mime = "video/avc";
+	private int width = 0;
+	private int height = 0;
+	private byte[] csd0 = null;
+	private byte[] csd1 = null;
+	
+	public int sampleSize = 0;
+	public byte[] sampleData;
+	public long presentationTime = 0;
+	
+	private static final long serialVersionUID = 1L;
+	
+	/**
+	 * 
+	 */
+	public vData(){
+		
+	}
+	
+	/**
+	 * 
+	 */
+	public vData(int _sampleSize, byte[] _sampleData, long _presentationTime){
+		sampleSize = _sampleSize;
+		sampleData = _sampleData;
+		presentationTime = _presentationTime;
+	}
+	
+	
+	/**
+	 * 
+	 */
+	public void setMediaFormat(String _mime, int _width, int _height, byte[] _csd0, byte[] _csd1){
+		mime = _mime;
+		width = _width;
+		height = _height;
+		csd0 = _csd0;
+		csd1 = _csd1;
+	}
+
+	/**
+	 * 
+	 */
+	public int getSampleSize(){
+		return sampleSize;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] getSampleData(){
+		return sampleData;
+	}
+
+	/**
+	 * 
+	 */
+	public long getPresentationTime(){
+		return presentationTime;
+	}	
+	/**
+	 * 
+	 */
+	public String getMime(){
+		return mime;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getWidth(){
+		return width;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getHeight(){
+		return height;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd0(){
+		return csd0;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd1(){
+		return csd1;
+	}
+
+	
+	@Override
+	public String toString() {
+		return sampleSize + " is sampleSize,  " + sampleData
+				+ " is sampleData,  " + presentationTime + " is prest. time";
+	}
+	
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/AndroidManifest.xml~ AndroidSource/packages/apps/TestApp/AndroidManifest.xml~
--- Original_4.4.4_r1/packages/apps/TestApp/AndroidManifest.xml~	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/AndroidManifest.xml~	2015-01-09 00:26:12.000000000 +0900
@@ -0,0 +1,38 @@
+<?xml version="1.0" encoding="utf-8"?>
+<manifest xmlns:android="http://schemas.android.com/apk/res/android"
+    package="com.test"
+    android:versionCode="1"
+    android:versionName="1.0" >
+
+    <uses-permission android:name="android.permission.INTERNET"/>
+    <uses-permission android:name="android.permission.VIBRATE"/>
+    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
+    <uses-permission android:name="android.permission.CHANGE_WIFI_STATE" />
+    <uses-permission android:name="android.permission.CHANGE_NETWORK_STATE" />
+    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
+    <uses-permission android:name="android.permission.READ_PHONE_STATE" />
+    <uses-permission android:name="android.permission.WRITE_SETTINGS" />
+    <uses-permission android:name="android.permission.WRITE_SECURE_SETTINGS" />
+   
+    
+    <uses-sdk
+        android:minSdkVersion="19"
+        android:targetSdkVersion="19" />
+    
+    <application
+        android:allowBackup="true"
+        android:icon="@drawable/ic_launcher"
+        android:label="@string/app_name"
+        android:theme="@style/AppTheme" >
+        <activity
+            android:name=".MainActivity"
+            android:label="@string/app_name" >
+            <intent-filter>
+                <action android:name="android.intent.action.MAIN" />
+
+                <category android:name="android.intent.category.LAUNCHER" />
+            </intent-filter>
+        </activity>
+    </application>
+
+</manifest>
diff -urN Original_4.4.4_r1/packages/apps/TestApp/Android.mk AndroidSource/packages/apps/TestApp/Android.mk
--- Original_4.4.4_r1/packages/apps/TestApp/Android.mk	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/Android.mk	2015-01-09 00:26:12.000000000 +0900
@@ -0,0 +1,18 @@
+LOCAL_PATH:= $(call my-dir)
+include $(CLEAR_VARS)
+
+LOCAL_MODULE_TAGS := optional
+
+LOCAL_SRC_FILES := $(call all-java-files-under, src)
+
+LOCAL_PACKAGE_NAME := TestApp 
+LOCAL_CERTIFICATE := platform
+LOCAL_PRIVILEGED_MODULE := true
+
+include $(BUILD_PACKAGE)
+
+include $(call all-makefiles-under, $(LOCAL_PATH))
+
+
+
+
diff -urN Original_4.4.4_r1/packages/apps/TestApp/Android.mk~ AndroidSource/packages/apps/TestApp/Android.mk~
--- Original_4.4.4_r1/packages/apps/TestApp/Android.mk~	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/Android.mk~	2015-01-09 00:26:12.000000000 +0900
@@ -0,0 +1,12 @@
+LOCAL_PATH:= $(call my-dir)
+include $(CLEAR_VARS)
+
+LOCAL_MODULE_TAGS := optional
+
+LOCAL_SRC_FILES := $(call all-java-files-under, src)
+
+LOCAL_PACKAGE_NAME := TestApp 
+
+include $(BUILD_PACKAGE)
+
+include $(call all-makefiles-under, $(LOCAL_PATH))
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/alert/RequestDialog.java AndroidSource/packages/apps/TestApp/src/com/test/alert/RequestDialog.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/alert/RequestDialog.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/alert/RequestDialog.java	2016-06-23 23:00:30.000000000 +0900
@@ -0,0 +1,214 @@
+package com.test.alert;
+
+import java.net.InetAddress;
+import java.net.NetworkInterface;
+import java.net.SocketException;
+import java.util.Enumeration;
+
+import com.test.R;
+import android.app.Activity;
+import android.app.AlertDialog;
+import android.app.KeyguardManager;
+import android.content.Context;
+import android.content.DialogInterface;
+import android.content.DialogInterface.OnClickListener;
+import android.content.DialogInterface.OnMultiChoiceClickListener;
+import android.content.Intent;
+import android.os.Bundle;
+import android.os.PowerManager;
+import android.os.PowerManager.WakeLock;
+import android.service.devicemanager.Device;
+import android.service.devicemanager.DeviceManager;
+import android.text.InputType;
+import android.util.Log;
+import android.view.KeyEvent;
+import android.view.Menu;
+import android.view.MenuItem;
+import android.view.View;
+import android.view.WindowManager;
+
+
+public class RequestDialog extends Activity
+{
+	private Context mContext;
+	
+	@Override
+	protected void onCreate(Bundle savedInstanceState)
+	{
+		mContext = getApplicationContext();
+		
+		super.onCreate(savedInstanceState);
+		setContentView(R.layout.activity_dialog);
+		
+		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
+		
+		showAlertDialog(getIntent().getStringExtra("deviceName"), getIntent().getIntArrayExtra("resources"));
+	}
+	
+	
+	
+	private void showAlertDialog(String deviceName, int[] resources) 
+	{
+		final DeviceManager dm = (DeviceManager)getSystemService(Context.DEVICE_MANAGEMENT_SERVICE);
+		
+        KeyguardManager km = (KeyguardManager) getSystemService(Context.KEYGUARD_SERVICE);
+        KeyguardManager.KeyguardLock kl = km.newKeyguardLock("MyKeyguardLock");
+            kl.disableKeyguard();
+
+        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
+        WakeLock wakeLock = pm.newWakeLock(PowerManager.FULL_WAKE_LOCK| PowerManager.ACQUIRE_CAUSES_WAKEUP
+                | PowerManager.ON_AFTER_RELEASE, "MyWakeLock");
+        wakeLock.acquire();
+
+        final String[] resourceNames = new String[resources.length];
+        final boolean[] isAllowed = new boolean[resources.length];
+        final int[] allowedResources = new int[resources.length];
+        
+        final String deviceName2 = deviceName;
+        final int[] resources2 = resources;
+        
+        int j = 0;
+        
+        for(int i : resources)
+        	resourceNames[j++] = i + ": " + Device.ResourceNames[i];
+        
+        AlertDialog.Builder builder = new AlertDialog.Builder(this);
+        builder.setTitle(deviceName);
+        //builder.setIcon(R.drawable.icon);
+        //builder.setMessage("Content");
+        builder.setCancelable(false);
+        
+        builder.setMultiChoiceItems(resourceNames, isAllowed, new OnMultiChoiceClickListener() {
+			
+			@Override
+			public void onClick(DialogInterface dialog, int which, boolean isChecked) {
+				// TODO Auto-generated method stub
+				
+			}
+		});
+        
+        builder.setPositiveButton("Allow", new OnClickListener() {
+			
+			@Override
+			public void onClick(DialogInterface dialog, int which) {
+				// TODO Auto-generated method stub
+				Log.d("REQUESTDIALOG", "name: " + resourceNames.toString() + "\nisAllowed" + isAllowed.toString());
+				for(int i=0; i<resources2.length; i++)
+				{
+					if(isAllowed[i])
+						allowedResources[i] = resources2[i];
+				}
+				dm.allowResources(deviceName2, allowedResources);
+				
+				dialog.dismiss();
+				CloseActivity();
+				/*android.os.Process.killProcess(android.os.Process.myPid());
+				System.exit(1);*/
+			}
+		});
+       
+        builder.setNegativeButton("Decline", new OnClickListener() {
+            public void onClick(DialogInterface dialog, int which) {
+            	dm.allowResources(deviceName2, null);
+            	
+                dialog.dismiss();
+                CloseActivity();
+                /*android.os.Process.killProcess(android.os.Process.myPid());
+				System.exit(1);*/
+            }
+        });
+        AlertDialog alert = builder.create();
+        alert.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
+        alert.show();
+            
+            
+        /*final CharSequence[] items = { getString(R.string.test1), getString(R.string.tes2), getString(R.string.test3), getString(R.string.cancel) };
+        AlertDialog.Builder builder = new AlertDialog.Builder(getApplicationContext());
+        builder.setTitle("Title");
+        builder.setItems(items, new DialogInterface.OnClickListener() {
+            @Override
+            public void onClick(DialogInterface dialog, int item) {
+                if (items[item].equals(getString(R.string.test1))) {
+                    dialog.dismiss();
+
+                } else if (items[item].equals(getString(R.string.test2))) {
+                    dialog.dismiss();
+
+                } else if (items[item].equals(getString(R.string.test3))) {
+
+                }else if (items[item].equals(getString(R.string.cancel))) {
+                    dialog.dismiss();
+
+
+                }
+            }
+        });
+
+        alert = builder.create();
+        alert.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
+        alert.getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON|
+                WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD|
+                WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED|
+                WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);
+
+
+        alert.show();
+
+        alert.setOnDismissListener(new OnDismissListener() {
+
+            @Override
+            public void onDismiss(DialogInterface arg0) {
+
+            }
+        });
+
+
+        alert.setOnCancelListener(new OnCancelListener() {
+
+            @Override
+            public void onCancel(DialogInterface dialog) {
+
+            }
+        });*/
+
+
+    }
+	
+	private void CloseActivity()
+    {
+        this.finish();
+    }
+	
+	@Override
+    public boolean onKeyDown(int keyCode, KeyEvent event) 
+	{
+		Log.d("TEST", event.getCharacters());
+		if ((keyCode == KeyEvent.KEYCODE_BACK)) 
+		{
+			return false;
+		}
+		return super.onKeyDown(keyCode, event);
+	}
+	
+	@Override
+	public boolean onCreateOptionsMenu(Menu menu)
+	{
+		// Inflate the menu; this adds items to the action bar if it is present.
+		getMenuInflater().inflate(R.menu.main, menu);
+		return true;
+	}
+
+	@Override
+	public boolean onOptionsItemSelected(MenuItem item)
+	{
+		// Handle action bar item clicks here. The action bar will
+		// automatically handle clicks on the Home/Up button, so long
+		// as you specify a parent activity in AndroidManifest.xml.
+		int id = item.getItemId();
+		if (id == R.id.action_settings)
+		{
+			return true;
+		}
+		return super.onOptionsItemSelected(item);
+	}
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/distribute/DistributeActivity.java AndroidSource/packages/apps/TestApp/src/com/test/distribute/DistributeActivity.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/distribute/DistributeActivity.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/distribute/DistributeActivity.java	2015-01-16 17:15:38.000000000 +0900
@@ -0,0 +1,46 @@
+package com.test.distribute;
+
+import com.test.R;
+
+import android.app.Activity;
+import android.os.Bundle;
+import android.service.distribute.Distributor;
+import android.view.Menu;
+import android.view.MenuItem;
+import android.widget.TextView;
+
+public class DistributeActivity extends Activity {
+
+	TextView tv;
+	Distributor distributor;
+	
+	@Override
+	protected void onCreate(Bundle savedInstanceState) {
+		super.onCreate(savedInstanceState);
+		setContentView(R.layout.activity_distribute);
+		
+		tv = (TextView) findViewById(R.id.distribute_txt);
+		distributor = (Distributor)getSystemService(DISTRIBUTED_COMPUTING_SERVICE);
+		
+		tv.setText(distributor.sum(10, 20));
+	}
+
+	@Override
+	public boolean onCreateOptionsMenu(Menu menu) {
+		// Inflate the menu; this adds items to the action bar if it is present.
+		getMenuInflater().inflate(R.menu.distribute, menu);
+		return true;
+	}
+
+	@Override
+	public boolean onOptionsItemSelected(MenuItem item) {
+		// Handle action bar item clicks here. The action bar will
+		// automatically handle clicks on the Home/Up button, so long
+		// as you specify a parent activity in AndroidManifest.xml.
+		int id = item.getItemId();
+		if (id == R.id.action_settings) {
+			return true;
+		}
+		return super.onOptionsItemSelected(item);
+	}
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/location/LocationActivity.java AndroidSource/packages/apps/TestApp/src/com/test/location/LocationActivity.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/location/LocationActivity.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/location/LocationActivity.java	2016-06-22 09:47:58.000000000 +0900
@@ -0,0 +1,98 @@
+package com.test.location;
+
+import android.app.Activity;
+import android.content.Context;
+import android.content.Intent;
+import android.location.Location;
+import android.location.LocationListener;
+import android.location.LocationManager;
+import android.os.Bundle;
+import android.provider.Settings;
+import android.service.remote.RemoteServiceManager;
+import android.util.Log;
+import android.view.View;
+import android.view.View.OnClickListener;
+import android.widget.Button;
+import android.widget.Toast;
+
+import com.test.R;
+
+public class LocationActivity extends Activity implements LocationListener {
+	 
+		private LocationManager locationManager;
+		private RemoteServiceManager mRemoteManager;
+	 
+		@Override
+		protected void onCreate(Bundle savedInstanceState) {
+	 
+			super.onCreate(savedInstanceState);
+			setContentView(R.layout.activity_location);
+	 
+			locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
+	 
+			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
+					0, 0, this);
+			locationManager.requestLocationUpdates(LocationManager.REMOTE_PROVIDER,
+					0, 0, this);
+			
+			mRemoteManager = (RemoteServiceManager) getSystemService(Context.REMOTE_SERVICE);
+	        Button test_btn = (Button) findViewById(R.id.test_btn);
+	        test_btn.setOnClickListener(new OnClickListener()
+			{
+				
+				@Override
+				public void onClick(View v)
+				{
+					mRemoteManager.testLocation();
+				}
+			});
+	 
+		}
+	 
+		@Override
+		public void onLocationChanged(Location location) {
+	 
+			String msg = location.getProvider() + "\t" + location.getLatitude() + "," + location.getLongitude()
+					+ "\t" + System.currentTimeMillis();
+			
+			int sourceDevice = 0;
+			
+			if(location.getExtras() != null)
+				sourceDevice = location.getExtras().getInt("SourceDevice");
+			
+			/*String msg = "Provider: " + location.getProvider() 
+					+ "\nNew Latitude: " + location.getLatitude()
+					+ "\nNew Longitude: " + location.getLongitude()
+					+ "\nSourceDevice: " + sourceDevice
+					+ "\nTime: " + System.currentTimeMillis();*/
+			
+			
+	 
+			//Toast.makeText(getBaseContext(), msg, Toast.LENGTH_LONG).show();
+			Log.d("APP", msg);
+		}
+	 
+		@Override
+		public void onProviderDisabled(String provider) {
+	 
+			/*Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
+			startActivity(intent);
+			Toast.makeText(getBaseContext(), "Gps is turned off!! ",
+					Toast.LENGTH_SHORT).show();*/
+		}
+	 
+		@Override
+		public void onProviderEnabled(String provider) {
+	 
+			Toast.makeText(getBaseContext(), "Gps is turned on!! ",
+					Toast.LENGTH_SHORT).show();
+		}
+	 
+		@Override
+		public void onStatusChanged(String provider, int status, Bundle extras) {
+			// TODO Auto-generated method stub
+	 
+		}
+	 
+	}
+
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/MainActivity.java AndroidSource/packages/apps/TestApp/src/com/test/MainActivity.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/MainActivity.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/MainActivity.java	2016-09-26 16:38:09.693426316 +0900
@@ -0,0 +1,347 @@
+package com.test;
+
+import java.net.InetAddress;
+import java.net.NetworkInterface;
+import java.net.SocketException;
+import java.util.ArrayList;
+import java.util.Enumeration;
+
+import android.app.Activity;
+import android.content.Context;
+import android.content.Intent;
+import android.os.Bundle;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.os.SystemVibrator;
+import android.os.Vibrator;
+import android.provider.Settings;
+import android.provider.Settings.SettingNotFoundException;
+import android.service.collaboroid.CollaboRoidManager;
+import android.service.devicemanager.Device;
+import android.service.devicemanager.DeviceManager;
+import android.service.distribute.Distributor;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteServiceManager;
+import android.text.InputType;
+import android.util.Log;
+import android.view.Menu;
+import android.view.MenuItem;
+import android.view.View;
+import android.view.View.OnClickListener;
+import android.view.WindowManager;
+import android.widget.Button;
+import android.widget.EditText;
+import android.widget.TextView;
+import android.widget.Toast;
+import android.widget.ToggleButton;
+import android.net.wifi.*;
+
+
+import com.google.android.collect.Lists;
+import com.test.location.LocationActivity;
+import com.test.recommendation.RecommendationTest;
+import com.test.sensor.ProxiActivity;
+import com.test.sensor.SensorActivity;
+import com.test.touch.TouchActivity;
+
+public class MainActivity extends Activity
+{
+	private Context mContext;
+	
+	RemoteServiceManager rrm;
+	Distributor dis;
+	DeviceManager dm;
+	
+	TextView ip_tv;
+	TextView info_tv;
+	
+	EditText ip_et;
+	
+	ToggleButton server_tg;
+	Button client_btn;
+	Button disconnect_btn;
+	Button location_test_btn;
+//	ToggleButton client_tg;
+	
+	@Override
+	protected void onCreate(Bundle savedInstanceState)
+	{
+		mContext = getApplicationContext();
+		
+		super.onCreate(savedInstanceState);
+		setContentView(R.layout.activity_main);
+		Log.d("ProxiActivity", "product: " + android.os.Build.PRODUCT);
+		Log.d("ProxiActivity", "product: " + android.os.Build.PRODUCT);
+		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
+		
+		rrm = (RemoteServiceManager)getSystemService(Context.REMOTE_SERVICE);
+		dis = (Distributor)getSystemService(Context.DISTRIBUTED_COMPUTING_SERVICE);
+		
+		findViewById(R.id.recommendation_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.vibrate_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.sensor_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.touch_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.test_btn).setOnClickListener(mClickListener);
+		
+		ip_tv = (TextView) findViewById(R.id.ip_tv);
+		ip_tv.setText(getIpAddress());
+		
+		
+		//////////////////////////////////////////
+		
+		info_tv = (TextView) findViewById(R.id.info_tv);
+		//info_tv.setText(getIpAddress());
+		
+		ip_et = (EditText) findViewById(R.id.ip_et);
+		ip_et.setText("192.168.0.");
+		ip_et.requestFocus();
+//		ip_et.setInputType(InputType.TYPE_CLASS_NUMBER);
+		
+		server_tg = (ToggleButton)findViewById(R.id.server_tg);
+		server_tg.setOnClickListener(mClickListener);
+		
+//		if(Settings.Global.getInt(getContentResolver(), Settings.Global.REMOTE_REQUEST_SERVER_ON, 0) > 0)
+//			server_tg.setChecked(true);
+//		else
+//			server_tg.setChecked(false);
+		
+		/////////////////////////////////////////
+		
+		location_test_btn = (Button)findViewById(R.id.location_test);
+		location_test_btn.setOnClickListener(new OnClickListener() {
+            
+            @Override
+            public void onClick(View v) {
+                // TODO Auto-generated method stub
+                for(int a=0;a<3;a++){
+                    rrm.testLocation();
+                    try {
+                        Thread.sleep(10000);
+                    } catch (InterruptedException e) {
+                        // TODO Auto-generated catch block
+                        e.printStackTrace();
+                    }
+                }
+            }
+        });
+		
+		
+		client_btn = (Button)findViewById(R.id.client_btn);
+		client_btn.setOnClickListener(new OnClickListener() {
+            
+		    @Override
+		    public void onClick(View v) {
+		        // TODO Auto-generated method stub
+		        rrm.connectToServer(ip_et.getText().toString());
+		        setRemoteRequestClientOn(true);
+		        Toast.makeText(mContext, "connect!", Toast.LENGTH_SHORT).show();
+		        
+		        ArrayList<Device> list_device = new ArrayList<Device>();
+		        Device d = new Device(ip_et.getText().toString(), "30", "aa", 1, 1);
+//		        d.setAllowedResources(new int[]{1,1,1,1,1,1,1});
+		        d.setAskedResources(new int[]{1,1,1,1,1,1,1});
+		        list_device.add(d);
+		        
+		        
+		        
+		        IRemoteService remoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+		        try {
+		            
+		            remoteService.sendResourceRequests(list_device);
+		            
+		            
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		        } catch (SettingNotFoundException e) {
+		            // TODO Auto-generated catch block
+		            e.printStackTrace();
+		        } catch (RemoteException re){
+		            re.printStackTrace();
+		        }
+		    }
+        });
+        
+		
+		disconnect_btn = (Button)findViewById(R.id.client_disconnect);
+		disconnect_btn.setOnClickListener(new OnClickListener() {
+            
+            @Override
+            public void onClick(View v) {
+                // TODO Auto-generated method stub
+//                rrm.disconnectToServer();
+                rrm.printServerIPs();
+                setRemoteRequestClientOn(false);
+                Toast.makeText(mContext, "disconnect!", Toast.LENGTH_SHORT).show();
+            }
+        });
+//		client_tg = (ToggleButton)findViewById(R.id.client_tg);
+//		client_tg.setOnClickListener(mClickListener);
+//		
+//		if(Settings.Global.getInt(getContentResolver(), Settings.Global.REMOTE_REQUEST_CLIENT_ON, 0) > 0)
+//			client_tg.setChecked(true);
+//		else
+//			client_tg.setChecked(false);
+	}
+	
+	Button.OnClickListener mClickListener = new View.OnClickListener()
+	{
+		public void onClick(View v)
+		{
+			switch (v.getId())
+			{
+				case R.id.recommendation_btn:
+					/*runOnUiThread(new Runnable()
+					{
+						@Override
+						public void run()
+						{
+							info_tv.setText(new RecommendationTest(
+									mContext).getDevice());
+						}
+					});*/
+					Intent i3 = new Intent(mContext, LocationActivity.class);
+					startActivity(i3);
+					break;
+				case R.id.vibrate_btn:
+					//new VibrateTest(getApplicationContext()).vibrate();
+				    
+				    Log.d("VibLatency", "test Vibrate");
+					vibrate(200);
+					
+					
+//					rrm.requestMotionEvents();
+					
+//				    SystemVibrator sv = new SystemVibrator();
+//				    sv.vibrate(100);
+				    
+					break;
+				case R.id.server_tg:
+				if(server_tg.isChecked())
+				{
+					//rrm.setEnabled(true);
+					rrm.startServer();
+					setRemoteRequestServerOn(true);
+					Toast.makeText(mContext, "startServer!", Toast.LENGTH_SHORT).show();
+					
+					//dis.startTaskExecutor();
+				}
+				else
+				{	
+					//rrm.setEnabled(false);
+					rrm.stopServer();
+					setRemoteRequestServerOn(false);
+					Toast.makeText(mContext, "stopServer!", Toast.LENGTH_SHORT).show();
+				}
+					break;
+//				case R.id.client_tg:
+//				if(client_tg.isChecked())
+//				{
+//					//rrm.setEnabled(true);
+//					rrm.connectToServer(ip_et.getText().toString());
+//					setRemoteRequestClientOn(true);
+//					Toast.makeText(mContext, "connect!", Toast.LENGTH_SHORT).show();
+//					
+//					//dis.startJobManager(ip_et.getText().toString());
+//				}
+//				else
+//				{	
+//					//rrm.setEnabled(false);
+//					rrm.disconnectToServer();
+//					setRemoteRequestClientOn(false);
+//					Toast.makeText(mContext, "disconnect!", Toast.LENGTH_SHORT).show();
+//				}
+//					break;
+				case R.id.sensor_btn:
+					Toast.makeText(mContext, "?!!", Toast.LENGTH_SHORT).show();
+					Intent i = new Intent(mContext, SensorActivity.class);
+					startActivity(i);
+					break;
+				case R.id.touch_btn:
+					Toast.makeText(mContext, "?!!", Toast.LENGTH_SHORT).show();
+					Intent i2 = new Intent(mContext, TouchActivity.class);
+					startActivity(i2);
+					break;
+				case R.id.test_btn:
+					//rrm.testOperation();
+					Intent i4 = new Intent(mContext, ProxiActivity.class);
+					startActivity(i4);
+					break;					
+			}
+		}
+	};
+	
+	private String getIpAddress() {
+ 		String ip = "";
+ 		try {
+ 			Enumeration<NetworkInterface> enumNetworkInterfaces = NetworkInterface
+ 					.getNetworkInterfaces();
+ 			while (enumNetworkInterfaces.hasMoreElements()) {
+
+ 				NetworkInterface networkInterface = enumNetworkInterfaces
+ 						.nextElement();
+ 				Enumeration<InetAddress> enumInetAddress = networkInterface
+ 						.getInetAddresses();
+
+ 				while (enumInetAddress.hasMoreElements()) {
+ 					InetAddress inetAddress = enumInetAddress.nextElement();
+
+ 					if (inetAddress.isSiteLocalAddress()) {
+ 						ip += "dSiteLocalAddress: "
+ 								+ inetAddress.getHostAddress().toString() + "\n";
+ 					}
+ 				}
+ 			}
+ 			ip += "nothing?";
+ 		} catch (SocketException e) {
+// 		   Socket socket = Socket("http://www.google.com", 80);
+ 		    
+ 		   
+ 		   
+ 		   return ip;
+// 		   e.printStackTrace();
+ 			
+ 		}
+ 		return ip;
+ 	}
+	
+	
+	
+	private void vibrate(long m)
+	{
+		Vibrator vibrator = (Vibrator)mContext.getSystemService(Context.VIBRATOR_SERVICE);
+		vibrator.vibrate(m);
+	}
+ 
+	private void setRemoteRequestServerOn(boolean enabling)
+	{
+		Settings.Global.putInt(mContext.getContentResolver(), "REMOTE_REQUEST_SERVER_ON", enabling ? 1 : 0);
+	}
+	
+	private void setRemoteRequestClientOn(boolean enabling)
+	{
+		Settings.Global.putInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON", enabling ? 1 : 0);
+	}
+
+	@Override
+	public boolean onCreateOptionsMenu(Menu menu)
+	{
+		// Inflate the menu; this adds items to the action bar if it is present.
+		getMenuInflater().inflate(R.menu.main, menu);
+		return true;
+	}
+
+	@Override
+	public boolean onOptionsItemSelected(MenuItem item)
+	{
+		// Handle action bar item clicks here. The action bar will
+		// automatically handle clicks on the Home/Up button, so long
+		// as you specify a parent activity in AndroidManifest.xml.
+		int id = item.getItemId();
+		if (id == R.id.action_settings)
+		{
+			return true;
+		}
+		return super.onOptionsItemSelected(item);
+	}
+}
